/*
 * Copyright (c) 1995 Akihiro Tominaga and the WIDE Project.
 * All rights reserved.
 *
 * Permission to use, copy and distribute this software in source and
 * binary forms is hereby granted provided that the above copyright
 * notice and this permission notice appear in all copies of the software,
 * derivative works or modified versions, and any portions thereof.
 * Furthermore, any supporting documentation, advertising materials,
 * and all other materials related to such a distribution and use must
 * acknowledge that the software was developed by Akihiro Tominaga and
 * the WIDE Project. The names of the author and the WIDE Project may
 * not be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef TRUE
#define TRUE   1
#endif
#ifndef FALSE
#define FALSE  0
#endif
#ifndef NBPFILTER
#define NBPFILTER   10
#endif

#define  INIT         0
#define  WAIT_OFFER   1
#define  SELECTING    2
#define  REQUESTING   3
#define  BOUND        4
#define  RENEWING     5
#define  REBINDING    6
#define  INIT_REBOOT  7
#define  VERIFY       8
#define  REBOOTING    9
#define  VERIFYING   10
#define  MAX_STATES  VERIFYING

#define OPTLEN(TAGP)   (*(((char *)TAGP) + 1))       /* get length of DHCP option */
#define OPTBODY(TAGP)  (((char *)TAGP) + 2)          /* get content of DHCP option */
#define DHCPLEN(UDP)  (ntohs(UDP->uh_ulen) - UDPHL)  /* get DHCP message size from
							struct udp */
#define CHKOFF(LEN)  (offopt + 2 + (LEN) < DFLTOPTLEN) /* check the option offset */

#define ETHERHL    sizeof(struct ether_header)
#define IPHL       sizeof(struct ip)
#define UDPHL      sizeof(struct udphdr)
#define WORD       4
#define QWOFF      2

#define OK         0

extern unsigned char magic_c[MAGIC_LEN];

int handle_ip();
int handle_num();
int handle_ips();
int handle_str();
int handle_bool();
int handle_ippairs();
int handle_nums();

struct ps_udph {              /* pseudo udp header for checksum */
  struct in_addr srcip,
                 dstip;
  char           zero,
                 prto;
  short          ulen;
};

struct msgbuf {
  char *buf;
  char *bptr;             /* for rcvmsg only */
  int bufsize;            /* for sndmsg only */
  int remain;
#ifndef sun
  struct bpf_hdr *bpf;
#endif
  struct ether_header *ether;
  struct ip *ip;
  struct udphdr *udp;
  struct dhcp *dhcp;
  struct ps_udph pudph;
};

/*
 * global variable
 */
extern struct msgbuf sndmsg;
extern struct msgbuf rcvmsg;
extern u_short dhcps_port,       /* DHCP server port (network byte order) */
               dhcpc_port;       /* DHCP client port (network byte order) */
extern int timeout;
extern int outputfd;
extern time_t init_epoch;
extern struct dhcp_param *_param;
